%% -*- octave -*-
%%
%% produces the adjacency matrix of a "lollipop" graph with a n-long
%% "stick."
%%
%% The result is a circle of order n
%%
function L = lollipop(n)
  L = zeros(n,n);
  for i = 2:n
    L(i,i-1) = 1;
    L(i-1,i) = 1;
  end
  L(1,n) = 1;
  L(n,1) = 1;
