%% -*- octave -*-

%% function b = init_b(n)
%%   b = ones(n, 1);
%%   i = 2;
%%   while (i <= n)
%%     b(i) = -1;
%%     i = i + 2;
%%   end
%%   if (i == n + 1)
%%     b(n - 1) = b(n - 1) - 1;
%%   end

function b = init_b_real(A)
  n = size(A)(1);
  b = (rand(n,1) < 0.5);
  b1 = zeros(n,1);
  for i = 1:n
    if (b(i) == 1)
      Adj_i = find(A(:,i));
      j = Adj_i(unidrnd(size(Adj_i)(1)));
      b1(j) = b1(j) + b(i);
    endif
  endfor
  b = b - b1;
endfunction
