% -*- octave -*-
%% return a random geometric graph on a square area
 
function [A,coord] = rgg_graph(n,l,r,matrix_type = "default")
 % if (using_sparse_matrix(n, matrix_type))
 %   A = sparse(n,n);
 % else
 %   A = zeros(n);
 % endif
  coord=rand(n,2)*l;
  [s,j]=sort(coord(:,1));
  coord=coord(j,:);
  coord2=coord.**2;
  r2=r**2;
  V=[];
  for i=1:n
      i
      rangeX = [coord(i,1)-r;coord(i,1)+r];
      %rangeY = [coord(i,2)-r;coord(i,2)+r];
      adjX = find(coord(:,1)>rangeX(1) & coord(:,1)<rangeX(2));
      i1=adjX(1);
      i2=adjX(size(adjX)(1));
      %adjY = coord(:,2)>rangeY(1) & coord(:,2)<rangeY(2);
      %adj=find(adjX & adjY);
      %for j=adj
      %  A(i,j)=1;
      %endfor
      c=(coord2(i1:i2,1)-2*coord(i,1)*coord(i1:i2,1)+coord2(i,1))+(coord2(i1:i2,2)-2*coord(i,2)*coord(i1:i2,2)+coord2(i,2))<=r2;
      c=[zeros(i1-1,1);c;zeros(n-(i2),1)];
      V=[V c];
  endfor
  %A=[V zeros(n,1)];
  %A=A+A';
  A=V-eye(n); 
  if (issymmetric(A)==0)
     A=[];
  endif
endfunction
