function test_FD_ba(n,v=0)
  ##A = ba_graph(n,2);
  chord;
  A=chord_graph(n,10);
  A1=make_col_stochastic(A);
  if (v==0)
    v=floor(rand(1,1)*1000);
  endif
  v_input_set = find(A1(v,:));
  for j = v_input_set
    r = 1 - A1(v,j);
    if r == 0
      printf("error: killing node %d makes node %d a dead end.\n", v, j);
    else
     A1(:,j) = A1(:,j)/r;
    endif
  endfor
  A1(:,v) = zeros(n,1);
  A1(v,:) = zeros(1,n);
  g1 = 1 - flipud(sort(abs(eigs(A1,2,"lm"))))(2);
  printf("v=%d gap1=%f gap2=%f\n",v,gap(A),g1);   
  if (g1<0.001)
    diameter(A1)
  endif                                              
