%% -*- octave -*-
%%
%% produces an Erdos-Renyi random graph of order n and edge-probability
%% p.
%%
function b = using_sparse_matrix(n, matrix_type="default")
  switch (matrix_type)
    case "sparse"
      b = 1;
    case "non-sparse"
      b = 0;
    otherwise
      b = (n > 1000);
  endswitch
